
QGIS Application - Bug report #14713

Return duplicated elements in SnapWithResultsWithinTolerances mode

2016-04-20 11:55 PM - Yun Lin

Status: Closed

Priority: Normal

Assignee:

Category: Digitising

Affected QGIS version:2.12.3 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 22674

Description

I used QGIS recently and found out the there is certain situation i got two same snapping results from QgsSnapper. And i debugged a

little, and found out a bug in the following place:

File : src/core/qgssnapper.cpp

Function :  int QgsSnapper::snapMapPoint( const QgsPoint& mapCoordPoint, QList<QgsSnappingResult>& snappingResult, const

QList<QgsPoint>& excludePoints )

The code :

QgsSnappingResult returnResult = evalIt.value();

  for ( evalIt = snappingResultList.begin(); evalIt != snappingResultList.end(); ++evalIt )

{

    if ( evalIt.value().snappedVertexNr != -1 )

  {

      returnResult = evalIt.value();

      snappingResultList.erase( evalIt );

      break;

    }

  }

//We return the preferred result

  snappingResult.push_back( returnResult );

if ( mSnapMode  QgsSnapper::SnapWithOneResult )

{

    //return only a single  result, nothing more to do

  }

  else if ( mSnapMode  QgsSnapper::SnapWithResultsForSamePosition )

{

    //take all snapping results within a certain tolerance because rounding differences may occur

    double tolerance = 0.000001;

for ( evalIt = snappingResultList.begin(); evalIt != snappingResultList.end(); ++evalIt )

{

      if ( returnResult.snappedVertex.sqrDist( evalIt.value().snappedVertex ) < tolerance*tolerance )

  {

        snappingResult.push_back( evalIt.value() );

      }

    }

}

else //take all results

{
    for ( evalIt = snappingResultList.begin(); evalIt != snappingResultList.end(); ++evalIt )

  {

      snappingResult.push_back( evalIt.value() );

    }

  }

The problem occurs when var 'snappingResultList' has no elements satisfied the  condition : 

if ( evalIt.value().snappedVertexNr != -1 )

And since the following code :

snappingResult.push_back( returnResult );

will push the first result(by QgsSnappingResult returnResult = evalIt.value();) anyway, and 

when we under 'SnapWithResultsWithinTolerances' snap mode, we will get two duplicated elements!

And since the problem is obvious, so no test case provided.

History

#1 - 2016-04-21 12:02 AM - Yun Lin

OK. It's also affected the mode 'SnapWithResultsForSamePosition' too

#2 - 2017-05-01 01:05 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#3 - 2019-03-09 03:08 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

QGIS 3.4 has recently become our new Long Term Release  (LTR) version. This is a major step in our history – a long term release version based on the

massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR  as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version

will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the

relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the

ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help

you plan your deployment of QGIS into an operational environment.
The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and

administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.
